<a name='assembly'></a>
# ConfigurationHelper

## Contents

- [ApplicationSettings](#T-ConfigurationHelper-Classes-ApplicationSettings 'ConfigurationHelper.Classes.ApplicationSettings')
  - [#ctor()](#M-ConfigurationHelper-Classes-ApplicationSettings-#ctor 'ConfigurationHelper.Classes.ApplicationSettings.#ctor')
  - [ConnectionString](#P-ConfigurationHelper-Classes-ApplicationSettings-ConnectionString 'ConfigurationHelper.Classes.ApplicationSettings.ConnectionString')
  - [Instance](#P-ConfigurationHelper-Classes-ApplicationSettings-Instance 'ConfigurationHelper.Classes.ApplicationSettings.Instance')
  - [IsProduction](#P-ConfigurationHelper-Classes-ApplicationSettings-IsProduction 'ConfigurationHelper.Classes.ApplicationSettings.IsProduction')
  - [LogFileName](#P-ConfigurationHelper-Classes-ApplicationSettings-LogFileName 'ConfigurationHelper.Classes.ApplicationSettings.LogFileName')
  - [LoggingDestination](#P-ConfigurationHelper-Classes-ApplicationSettings-LoggingDestination 'ConfigurationHelper.Classes.ApplicationSettings.LoggingDestination')
  - [QueryTimeoutInSeconds](#P-ConfigurationHelper-Classes-ApplicationSettings-QueryTimeoutInSeconds 'ConfigurationHelper.Classes.ApplicationSettings.QueryTimeoutInSeconds')
  - [UsingLogging](#P-ConfigurationHelper-Classes-ApplicationSettings-UsingLogging 'ConfigurationHelper.Classes.ApplicationSettings.UsingLogging')
- [Environment](#T-ConfigurationHelper-Classes-Environment 'ConfigurationHelper.Classes.Environment')
  - [IsProduction](#P-ConfigurationHelper-Classes-Environment-IsProduction 'ConfigurationHelper.Classes.Environment.IsProduction')
- [Helper](#T-ConfigurationHelper-Helper 'ConfigurationHelper.Helper')
  - [ConfigurationFileName](#P-ConfigurationHelper-Helper-ConfigurationFileName 'ConfigurationHelper.Helper.ConfigurationFileName')
  - [ConfigurationMainBuilderRoot()](#M-ConfigurationHelper-Helper-ConfigurationMainBuilderRoot 'ConfigurationHelper.Helper.ConfigurationMainBuilderRoot')
  - [GetConnectionString()](#M-ConfigurationHelper-Helper-GetConnectionString 'ConfigurationHelper.Helper.GetConnectionString')
  - [GetEnvironment()](#M-ConfigurationHelper-Helper-GetEnvironment 'ConfigurationHelper.Helper.GetEnvironment')
  - [GetLogOptions()](#M-ConfigurationHelper-Helper-GetLogOptions 'ConfigurationHelper.Helper.GetLogOptions')
  - [InitMainConfiguration()](#M-ConfigurationHelper-Helper-InitMainConfiguration 'ConfigurationHelper.Helper.InitMainConfiguration')
  - [InitOptions\`\`1(section)](#M-ConfigurationHelper-Helper-InitOptions``1-System-String- 'ConfigurationHelper.Helper.InitOptions``1(System.String)')
- [Logging](#T-ConfigurationHelper-Classes-Logging 'ConfigurationHelper.Classes.Logging')
  - [Destination](#P-ConfigurationHelper-Classes-Logging-Destination 'ConfigurationHelper.Classes.Logging.Destination')
  - [LogFileName](#P-ConfigurationHelper-Classes-Logging-LogFileName 'ConfigurationHelper.Classes.Logging.LogFileName')
  - [Use](#P-ConfigurationHelper-Classes-Logging-Use 'ConfigurationHelper.Classes.Logging.Use')
- [LoggingDestination](#T-ConfigurationHelper-Classes-LoggingDestination 'ConfigurationHelper.Classes.LoggingDestination')
  - [DebugWindow](#F-ConfigurationHelper-Classes-LoggingDestination-DebugWindow 'ConfigurationHelper.Classes.LoggingDestination.DebugWindow')
  - [LogFile](#F-ConfigurationHelper-Classes-LoggingDestination-LogFile 'ConfigurationHelper.Classes.LoggingDestination.LogFile')
  - [None](#F-ConfigurationHelper-Classes-LoggingDestination-None 'ConfigurationHelper.Classes.LoggingDestination.None')

<a name='T-ConfigurationHelper-Classes-ApplicationSettings'></a>
## ApplicationSettings `type`

##### Namespace

ConfigurationHelper.Classes

##### Summary

Container for application settings which currently focuses on databases settings

##### Remarks

See usage
https://github.com/karenpayneoregon/ef-core5-logging/blob/master/LogToFile/Context/SchoolContext.cs#L40-L58

<a name='M-ConfigurationHelper-Classes-ApplicationSettings-#ctor'></a>
### #ctor() `constructor`

##### Summary

Get settings from appsettings.json

##### Parameters

This constructor has no parameters.

<a name='P-ConfigurationHelper-Classes-ApplicationSettings-ConnectionString'></a>
### ConnectionString `property`

##### Summary

Database connection string

<a name='P-ConfigurationHelper-Classes-ApplicationSettings-Instance'></a>
### Instance `property`

##### Summary

Access point to methods and properties

<a name='P-ConfigurationHelper-Classes-ApplicationSettings-IsProduction'></a>
### IsProduction `property`

##### Summary

Using production or development (refactor for more environments)

<a name='P-ConfigurationHelper-Classes-ApplicationSettings-LogFileName'></a>
### LogFileName `property`

##### Summary

File name when [LoggingDestination](#T-ConfigurationHelper-Classes-LoggingDestination 'ConfigurationHelper.Classes.LoggingDestination') is set to [LogFile](#F-ConfigurationHelper-Classes-LoggingDestination-LogFile 'ConfigurationHelper.Classes.LoggingDestination.LogFile')

<a name='P-ConfigurationHelper-Classes-ApplicationSettings-LoggingDestination'></a>
### LoggingDestination `property`

##### Summary

Type of logging [LoggingDestination](#P-ConfigurationHelper-Classes-ApplicationSettings-LoggingDestination 'ConfigurationHelper.Classes.ApplicationSettings.LoggingDestination')

<a name='P-ConfigurationHelper-Classes-ApplicationSettings-QueryTimeoutInSeconds'></a>
### QueryTimeoutInSeconds `property`

##### Summary

Timeout for queries (refactor appsettings for dynamic read)

<a name='P-ConfigurationHelper-Classes-ApplicationSettings-UsingLogging'></a>
### UsingLogging `property`

##### Summary

Indicates whether EF Core logging is enabled

<a name='T-ConfigurationHelper-Classes-Environment'></a>
## Environment `type`

##### Namespace

ConfigurationHelper.Classes

##### Summary

Container for setting environment for things like database connection string

<a name='P-ConfigurationHelper-Classes-Environment-IsProduction'></a>
### IsProduction `property`

##### Summary

True for working in prod, false for dev environment

<a name='T-ConfigurationHelper-Helper'></a>
## Helper `type`

##### Namespace

ConfigurationHelper

##### Summary

Provides service to read appsettings.json

<a name='P-ConfigurationHelper-Helper-ConfigurationFileName'></a>
### ConfigurationFileName `property`

##### Summary

Configuration file name to read from.

<a name='M-ConfigurationHelper-Helper-ConfigurationMainBuilderRoot'></a>
### ConfigurationMainBuilderRoot() `method`

##### Summary

Initialization

##### Returns

[IConfigurationRoot](#T-Microsoft-Extensions-Configuration-IConfigurationRoot 'Microsoft.Extensions.Configuration.IConfigurationRoot')

##### Parameters

This method has no parameters.

<a name='M-ConfigurationHelper-Helper-GetConnectionString'></a>
### GetConnectionString() `method`

##### Summary

Get connection string based on environment

##### Parameters

This method has no parameters.

<a name='M-ConfigurationHelper-Helper-GetEnvironment'></a>
### GetEnvironment() `method`

##### Summary

Determines if application is running dev or prod environment

##### Returns



##### Parameters

This method has no parameters.

<a name='M-ConfigurationHelper-Helper-GetLogOptions'></a>
### GetLogOptions() `method`

##### Summary



##### Returns



##### Parameters

This method has no parameters.

<a name='M-ConfigurationHelper-Helper-InitMainConfiguration'></a>
### InitMainConfiguration() `method`

##### Summary

Initialize ConfigurationBuilder for appsettings

##### Returns

IConfigurationRoot

##### Parameters

This method has no parameters.

<a name='M-ConfigurationHelper-Helper-InitOptions``1-System-String-'></a>
### InitOptions\`\`1(section) `method`

##### Summary

Generic method to read a section from the json configuration file.

##### Returns

Instance of T

##### Parameters

| Name | Type | Description |
| ---- | ---- | ----------- |
| section | [System.String](http://msdn.microsoft.com/query/dev14.query?appId=Dev14IDEF1&l=EN-US&k=k:System.String 'System.String') | Section to read |

##### Generic Types

| Name | Description |
| ---- | ----------- |
| T | Class type |

<a name='T-ConfigurationHelper-Classes-Logging'></a>
## Logging `type`

##### Namespace

ConfigurationHelper.Classes

##### Summary



<a name='P-ConfigurationHelper-Classes-Logging-Destination'></a>
### Destination `property`

##### Summary



<a name='P-ConfigurationHelper-Classes-Logging-LogFileName'></a>
### LogFileName `property`

##### Summary

File name when [LoggingDestination](#T-ConfigurationHelper-Classes-LoggingDestination 'ConfigurationHelper.Classes.LoggingDestination') is set to [LogFile](#F-ConfigurationHelper-Classes-LoggingDestination-LogFile 'ConfigurationHelper.Classes.LoggingDestination.LogFile')

<a name='P-ConfigurationHelper-Classes-Logging-Use'></a>
### Use `property`

##### Summary



<a name='T-ConfigurationHelper-Classes-LoggingDestination'></a>
## LoggingDestination `type`

##### Namespace

ConfigurationHelper.Classes

##### Summary

Where to log or not to log too

<a name='F-ConfigurationHelper-Classes-LoggingDestination-DebugWindow'></a>
### DebugWindow `constants`

##### Summary

Log to Output window

<a name='F-ConfigurationHelper-Classes-LoggingDestination-LogFile'></a>
### LogFile `constants`

##### Summary

Log to file

<a name='F-ConfigurationHelper-Classes-LoggingDestination-None'></a>
### None `constants`

##### Summary

No logging
