﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Runtime.InteropServices;
using Microsoft.VisualStudio.TestTools.UnitTesting;

// ReSharper disable once CheckNamespace - DO NOT add .Base as per partial class
namespace UnitTestsProject
{
    public partial class JsonTest
    {
        [DllImport("kernel32")]
        static extern ulong GetTickCount64();

        private string _computerJsonFileName = "computerDateInfo.json";

        [ClassInitialize()]
        public static void MyClassInitialize(TestContext testContext)
        {
            TestResults = new List<TestContext>();
        }

        [TestInitialize]
        public void Init()
        {
            if (TestContext.TestName != nameof(Deserialize_Object_With_UpTime) && 
                TestContext.TestName != nameof(Deserialize_Object_With_UnixEpochDateTime)) return;
            
            if (!File.Exists(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, _computerJsonFileName))) return;
            
            try
            {
                File.Delete(_computerJsonFileName);
            }
            catch (Exception e)
            {
                Debug.WriteLine(e);
            }
        }

        /// <summary>
        /// Get up time for current computer as a <see cref="TimeSpan"/>
        /// </summary>
        /// <returns>Up time for current computer</returns>
        public static TimeSpan GetUpTime() => TimeSpan.FromMilliseconds(GetTickCount64());

    }

}
