﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SystemTextJsonLibrary;

namespace Publisher.Classes
{
    public class ApplicationSettings
    {
        private static readonly Lazy<ApplicationSettings> Lazy =
            new(() => new ApplicationSettings());

        /// <summary>
        /// Access point to methods and properties
        /// </summary>
        public static ApplicationSettings Instance => Lazy.Value;

        /// <summary>
        /// Location of nuget.exe
        /// </summary>
        public string NuGetExecutable { get; set; }
        /// <summary>
        /// Local NuGet feed folder
        /// </summary>
        public string PackageLocation { get; set; }
        /// <summary>
        /// Assign properties from appsettings.json configuration file
        /// </summary>
        private ApplicationSettings()
        {
            var settings = JsonWorkers.JSonToItem<Configuration>("appsettings.json");
            NuGetExecutable = settings.NuGetExecutable;
            PackageLocation = settings.PackageLocation;
        }
    }
}
