﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Publisher.Classes;

namespace Publisher
{
    public partial class MainWindow : Form
    {
        private readonly BindingSource _bindingSource = new ();
        public MainWindow()
        {
            InitializeComponent();
            Shown += OnShown;
        }

        private void OnShown(object sender, EventArgs e)
        {
            _bindingSource.DataSource = DirectoryHelper.ProjectItems(SolutionHelper.ProjectNames(DirectoryHelper.SolutionName()));
            ProjectListBox.DataSource = _bindingSource;
            
            _bindingSource.PositionChanged += BindingSourceOnPositionChanged;
            
            PositionChanged();
            
        }

        private void BindingSourceOnPositionChanged(object sender, EventArgs e)
        {
            PositionChanged();
        }

        private void PositionChanged()
        {
            VersionsListBox.DataSource = ((ProjectItem) _bindingSource.Current).PackageList;
        }

        private async void PublishButton_Click(object sender, EventArgs e)
        {
            var currentProject = (ProjectItem) _bindingSource.Current;
            var currentPackage = (Package) VersionsListBox.SelectedItem;
            
            await PackHelpers.Publish(
                Path.Combine(currentProject.Path, currentPackage.Name), 
                CopyCommandCheckBox.Checked);
            
            MessageBox.Show(@"Done");

        }

        private void OpenLocalFeedFolderButton_Click(object sender, EventArgs e)
        {
            PackHelpers.OpenFeedFolder();
        }
    }
}
