﻿using System;
using System.IO;
using System.Text.Json;

namespace SystemTextJsonLibrary
{
    public static class JsonWorkers
    {
        /// <summary>
        /// Serialize string to specific type
        /// </summary>
        /// <typeparam name="T">Type to serialize</typeparam>
        /// <param name="sender"></param>
        /// <param name="fileName">File name to write too</param>
        /// <param name="format">Use formatting for serialization or not</param>
        /// <returns></returns>
        public static (bool result, Exception exception) SerializeFormatted<T>(T sender, string fileName, bool format = true)
        {

            try
            {

                var options = new JsonSerializerOptions { WriteIndented = true };
                File.WriteAllText(fileName, JsonSerializer.Serialize(sender, (format ? options : null)));

                return (true, null);

            }
            catch (Exception e)
            {
                return (false, e);
            }

        }
        /// <summary>
        /// Read json, deserialize to T
        /// </summary>
        /// <typeparam name="T">Type to create from json</typeparam>
        /// <param name="fileName">File to read details from</param>
        /// <returns>Instance of T</returns>
        public static T JSonToItem<T>(string fileName)
        {
            var json = File.ReadAllText(fileName);
            return JsonSerializer.Deserialize<T>(json);
        }

    }
}