﻿using System;
using static System.DateTime;

namespace SystemTextJsonLibrary.LanguageExtensions
{
    public static class HelperExtensions
    {
        /// <summary>
        /// Remove milliseconds from a given date time
        /// </summary>
        /// <param name="dateTime">Valid date time</param>
        /// <returns>Datetime with no milliseconds</returns>
        public static DateTime RemoveMilliseconds(this DateTime dateTime) =>
            ParseExact(dateTime.ToString("yyyy-MM-dd HH:mm:ss"), "yyyy-MM-dd HH:mm:ss", null);

        /// <summary>
        /// Remove seconds from a given date time
        /// </summary>
        /// <param name="dateTime">Valid date time</param>
        /// <returns>Datetime with no seconds</returns>
        public static DateTime RemoveSeconds(this DateTime dateTime) =>
            ParseExact(dateTime.ToString("yyyy-MM-dd HH:mm"), "yyyy-MM-dd HH:mm", null);

        /// <summary>
        /// Remove seconds and milliseconds from a given date time
        /// </summary>
        /// <param name="dateTime">Valid date time</param>
        /// <returns>Datetime with no seconds or milliseconds</returns>
        public static DateTime RemoveMillisecondsAndSeconds(this DateTime dateTime) =>
            ParseExact(dateTime.ToString("yyyy-MM-dd HH:mm"), "yyyy-MM-dd HH:mm", null);
    }
}
